From 9174c0242c6768d767557fc376b990f2d2d0d8dc Mon Sep 17 00:00:00 2001
From: Andres Freund <andres@anarazel.de>
Date: Mon, 28 Oct 2019 16:12:12 -0700
Subject: [PATCH] Merge Hash nodes into their associated HashJoin node.

---
 src/backend/commands/explain.c          |   73 +-
 src/backend/executor/Makefile           |    2 +-
 src/backend/executor/execAmi.c          |    5 -
 src/backend/executor/execParallel.c     |   30 +-
 src/backend/executor/execProcnode.c     |   17 -
 src/backend/executor/nodeHash.c         | 3338 -----------------------
 src/backend/executor/nodeHashjoin.c     | 3303 +++++++++++++++++++++-
 src/backend/nodes/copyfuncs.c           |   38 +-
 src/backend/nodes/outfuncs.c            |   27 +-
 src/backend/nodes/readfuncs.c           |   30 +-
 src/backend/optimizer/path/costsize.c   |    2 +-
 src/backend/optimizer/plan/createplan.c |   91 +-
 src/backend/optimizer/plan/setrefs.c    |   62 +-
 src/backend/optimizer/plan/subselect.c  |    1 -
 src/include/executor/nodeHash.h         |   79 -
 src/include/executor/nodeHashjoin.h     |   13 +-
 src/include/nodes/execnodes.h           |   73 +-
 src/include/nodes/nodes.h               |    2 -
 src/include/nodes/plannodes.h           |   46 +-
 src/test/regress/expected/join_hash.out |   28 +-
 src/test/regress/sql/join_hash.sql      |    8 +-
 21 files changed, 3488 insertions(+), 3780 deletions(-)
 delete mode 100644 src/backend/executor/nodeHash.c
 delete mode 100644 src/include/executor/nodeHash.h

diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index 62fb3434a32..b9130ce351b 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -18,7 +18,7 @@
 #include "commands/createas.h"
 #include "commands/defrem.h"
 #include "commands/prepare.h"
-#include "executor/nodeHash.h"
+#include "executor/nodeHashjoin.h"
 #include "foreign/fdwapi.h"
 #include "jit/jit.h"
 #include "nodes/extensible.h"
@@ -101,7 +101,7 @@ static void show_sortorder_options(StringInfo buf, Node *sortexpr,
 static void show_tablesample(TableSampleClause *tsc, PlanState *planstate,
 							 List *ancestors, ExplainState *es);
 static void show_sort_info(SortState *sortstate, ExplainState *es);
-static void show_hash_info(HashState *hashstate, ExplainState *es);
+static void show_hash_info(HashJoinState *hashjoinstate, ExplainState *es);
 static void show_tidbitmap_info(BitmapHeapScanState *planstate,
 								ExplainState *es);
 static void show_instrumentation_count(const char *qlabel, int which,
@@ -1291,9 +1291,6 @@ ExplainNode(PlanState *planstate, List *ancestors,
 		case T_Limit:
 			pname = sname = "Limit";
 			break;
-		case T_Hash:
-			pname = sname = "Hash";
-			break;
 		default:
 			pname = sname = "???";
 			break;
@@ -1822,6 +1819,10 @@ ExplainNode(PlanState *planstate, List *ancestors,
 			if (plan->qual)
 				show_instrumentation_count("Rows Removed by Filter", 2,
 										   planstate, es);
+
+			show_hash_info(castNode(HashJoinState, planstate), es);
+			break;
+
 			break;
 		case T_Agg:
 			show_agg_keys(castNode(AggState, planstate), ancestors, es);
@@ -1857,9 +1858,6 @@ ExplainNode(PlanState *planstate, List *ancestors,
 			show_modifytable_info(castNode(ModifyTableState, planstate), ancestors,
 								  es);
 			break;
-		case T_Hash:
-			show_hash_info(castNode(HashState, planstate), es);
-			break;
 		default:
 			break;
 	}
@@ -1966,11 +1964,66 @@ ExplainNode(PlanState *planstate, List *ancestors,
 		ExplainNode(outerPlanState(planstate), ancestors,
 					"Outer", NULL, es);
 
+	/* XXX: Temporary hack to hide explain changes */
+	if (IsA(plan, HashJoin))
+	{
+		if (es->format == EXPLAIN_FORMAT_TEXT)
+		{
+			if (es->indent)
+			{
+				appendStringInfoSpaces(es->str, es->indent * 2);
+				appendStringInfoString(es->str, "->  ");
+				es->indent += 2;
+			}
+			if (plan->parallel_aware)
+				appendStringInfoString(es->str, "Parallel ");
+			appendStringInfoString(es->str, "Hash\n");
+			es->indent++;
+		}
+
+		/* fake up Hash targetlist */
+		if (es->verbose)
+		{
+			List	   *context;
+			List	   *result = NIL;
+			bool		useprefix;
+			ListCell   *lc;
+
+			/* Set up deparsing context */
+			context = set_deparse_context_planstate(es->deparse_cxt,
+													(Node *) planstate,
+													ancestors);
+			useprefix = list_length(es->rtable) > 1;
+
+			/* Deparse each result column (we now include resjunk ones) */
+			foreach(lc, ((HashJoin *) plan)->inner_tlist)
+			{
+				TargetEntry *tle = (TargetEntry *) lfirst(lc);
+
+				result = lappend(result,
+								 deparse_expression((Node *) tle->expr, context,
+													useprefix, false));
+			}
+
+			/* Print results */
+			ExplainPropertyList("Output", result, es);
+		}
+	}
+
 	/* righttree */
 	if (innerPlanState(planstate))
 		ExplainNode(innerPlanState(planstate), ancestors,
 					"Inner", NULL, es);
 
+	/* XXX: Temporary hack to hide explain changes */
+	if (IsA(plan, HashJoin))
+	{
+		if (es->format == EXPLAIN_FORMAT_TEXT)
+		{
+			es->indent -= 3;
+		}
+	}
+
 	/* special child plans */
 	switch (nodeTag(plan))
 	{
@@ -2616,7 +2669,7 @@ show_sort_info(SortState *sortstate, ExplainState *es)
  * Show information on hash buckets/batches.
  */
 static void
-show_hash_info(HashState *hashstate, ExplainState *es)
+show_hash_info(HashJoinState *hashstate, ExplainState *es)
 {
 	HashInstrumentation hinstrument = {0};
 
@@ -2628,7 +2681,7 @@ show_hash_info(HashState *hashstate, ExplainState *es)
 	 * prepared to get instrumentation data from all participants.
 	 */
 	if (hashstate->hashtable)
-		ExecHashGetInstrumentation(&hinstrument, hashstate->hashtable);
+		ExecHashJoinGetInstrumentation(&hinstrument, hashstate->hashtable);
 
 	/*
 	 * Merge results from workers.  In the parallel-oblivious case, the
diff --git a/src/backend/executor/Makefile b/src/backend/executor/Makefile
index cc09895fa5c..057a8b72f72 100644
--- a/src/backend/executor/Makefile
+++ b/src/backend/executor/Makefile
@@ -20,7 +20,7 @@ OBJS = execAmi.o execCurrent.o execExpr.o execExprInterp.o \
        nodeBitmapAnd.o nodeBitmapOr.o \
        nodeBitmapHeapscan.o nodeBitmapIndexscan.o \
        nodeCustom.o nodeFunctionscan.o nodeGather.o \
-       nodeHash.o nodeHashjoin.o nodeIndexscan.o nodeIndexonlyscan.o \
+       nodeHashjoin.o nodeIndexscan.o nodeIndexonlyscan.o \
        nodeLimit.o nodeLockRows.o nodeGatherMerge.o \
        nodeMaterial.o nodeMergeAppend.o nodeMergejoin.o nodeModifyTable.o \
        nodeNestloop.o nodeProjectSet.o nodeRecursiveunion.o nodeResult.o \
diff --git a/src/backend/executor/execAmi.c b/src/backend/executor/execAmi.c
index 1f18e5d3a2f..d98a274346b 100644
--- a/src/backend/executor/execAmi.c
+++ b/src/backend/executor/execAmi.c
@@ -29,7 +29,6 @@
 #include "executor/nodeGatherMerge.h"
 #include "executor/nodeGroup.h"
 #include "executor/nodeGroup.h"
-#include "executor/nodeHash.h"
 #include "executor/nodeHashjoin.h"
 #include "executor/nodeIndexonlyscan.h"
 #include "executor/nodeIndexscan.h"
@@ -270,10 +269,6 @@ ExecReScan(PlanState *node)
 			ExecReScanUnique((UniqueState *) node);
 			break;
 
-		case T_HashState:
-			ExecReScanHash((HashState *) node);
-			break;
-
 		case T_SetOpState:
 			ExecReScanSetOp((SetOpState *) node);
 			break;
diff --git a/src/backend/executor/execParallel.c b/src/backend/executor/execParallel.c
index 53cd2fc666b..af13356525d 100644
--- a/src/backend/executor/execParallel.c
+++ b/src/backend/executor/execParallel.c
@@ -29,7 +29,6 @@
 #include "executor/nodeBitmapHeapscan.h"
 #include "executor/nodeCustom.h"
 #include "executor/nodeForeignscan.h"
-#include "executor/nodeHash.h"
 #include "executor/nodeHashjoin.h"
 #include "executor/nodeIndexscan.h"
 #include "executor/nodeIndexonlyscan.h"
@@ -268,13 +267,9 @@ ExecParallelEstimate(PlanState *planstate, ExecParallelEstimateContext *e)
 									   e->pcxt);
 			break;
 		case T_HashJoinState:
-			if (planstate->plan->parallel_aware)
-				ExecHashJoinEstimate((HashJoinState *) planstate,
-									 e->pcxt);
-			break;
-		case T_HashState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
-			ExecHashEstimate((HashState *) planstate, e->pcxt);
+			ExecHashJoinEstimate((HashJoinState *) planstate,
+								 e->pcxt);
 			break;
 		case T_SortState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
@@ -481,13 +476,9 @@ ExecParallelInitializeDSM(PlanState *planstate,
 											d->pcxt);
 			break;
 		case T_HashJoinState:
-			if (planstate->plan->parallel_aware)
-				ExecHashJoinInitializeDSM((HashJoinState *) planstate,
-										  d->pcxt);
-			break;
-		case T_HashState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
-			ExecHashInitializeDSM((HashState *) planstate, d->pcxt);
+			ExecHashJoinInitializeDSM((HashJoinState *) planstate,
+									  d->pcxt);
 			break;
 		case T_SortState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
@@ -953,7 +944,6 @@ ExecParallelReInitializeDSM(PlanState *planstate,
 				ExecHashJoinReInitializeDSM((HashJoinState *) planstate,
 											pcxt);
 			break;
-		case T_HashState:
 		case T_SortState:
 			/* these nodes have DSM state, but no reinitialization is required */
 			break;
@@ -1015,8 +1005,8 @@ ExecParallelRetrieveInstrumentation(PlanState *planstate,
 		case T_SortState:
 			ExecSortRetrieveInstrumentation((SortState *) planstate);
 			break;
-		case T_HashState:
-			ExecHashRetrieveInstrumentation((HashState *) planstate);
+		case T_HashJoinState:
+			ExecHashJoinRetrieveInstrumentation((HashJoinState *) planstate);
 			break;
 		default:
 			break;
@@ -1289,13 +1279,9 @@ ExecParallelInitializeWorker(PlanState *planstate, ParallelWorkerContext *pwcxt)
 											   pwcxt);
 			break;
 		case T_HashJoinState:
-			if (planstate->plan->parallel_aware)
-				ExecHashJoinInitializeWorker((HashJoinState *) planstate,
-											 pwcxt);
-			break;
-		case T_HashState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
-			ExecHashInitializeWorker((HashState *) planstate, pwcxt);
+			ExecHashJoinInitializeWorker((HashJoinState *) planstate,
+										 pwcxt);
 			break;
 		case T_SortState:
 			/* even when not parallel-aware, for EXPLAIN ANALYZE */
diff --git a/src/backend/executor/execProcnode.c b/src/backend/executor/execProcnode.c
index c227282975a..0979715ba05 100644
--- a/src/backend/executor/execProcnode.c
+++ b/src/backend/executor/execProcnode.c
@@ -86,7 +86,6 @@
 #include "executor/nodeGather.h"
 #include "executor/nodeGatherMerge.h"
 #include "executor/nodeGroup.h"
-#include "executor/nodeHash.h"
 #include "executor/nodeHashjoin.h"
 #include "executor/nodeIndexonlyscan.h"
 #include "executor/nodeIndexscan.h"
@@ -344,11 +343,6 @@ ExecInitNode(Plan *node, EState *estate, int eflags)
 													   estate, eflags);
 			break;
 
-		case T_Hash:
-			result = (PlanState *) ExecInitHash((Hash *) node,
-												estate, eflags);
-			break;
-
 		case T_SetOp:
 			result = (PlanState *) ExecInitSetOp((SetOp *) node,
 												 estate, eflags);
@@ -497,10 +491,6 @@ MultiExecProcNode(PlanState *node)
 			 * Only node types that actually support multiexec will be listed
 			 */
 
-		case T_HashState:
-			result = MultiExecHash((HashState *) node);
-			break;
-
 		case T_BitmapIndexScanState:
 			result = MultiExecBitmapIndexScan((BitmapIndexScanState *) node);
 			break;
@@ -710,10 +700,6 @@ ExecEndNode(PlanState *node)
 			ExecEndUnique((UniqueState *) node);
 			break;
 
-		case T_HashState:
-			ExecEndHash((HashState *) node);
-			break;
-
 		case T_SetOpState:
 			ExecEndSetOp((SetOpState *) node);
 			break;
@@ -775,9 +761,6 @@ ExecShutdownNode(PlanState *node)
 		case T_GatherMergeState:
 			ExecShutdownGatherMerge((GatherMergeState *) node);
 			break;
-		case T_HashState:
-			ExecShutdownHash((HashState *) node);
-			break;
 		case T_HashJoinState:
 			ExecShutdownHashJoin((HashJoinState *) node);
 			break;
diff --git a/src/backend/executor/nodeHashjoin.c b/src/backend/executor/nodeHashjoin.c
index ec37558c127..5b566ba85ab 100644
--- a/src/backend/executor/nodeHashjoin.c
+++ b/src/backend/executor/nodeHashjoin.c
@@ -106,16 +106,25 @@
 
 #include "postgres.h"
 
+#include <math.h>
+#include <limits.h>
+
 #include "access/htup_details.h"
 #include "access/parallel.h"
+#include "catalog/pg_statistic.h"
+#include "commands/tablespace.h"
+#include "executor/execdebug.h"
 #include "executor/executor.h"
 #include "executor/hashjoin.h"
-#include "executor/nodeHash.h"
 #include "executor/nodeHashjoin.h"
 #include "miscadmin.h"
 #include "pgstat.h"
+#include "port/atomics.h"
+#include "utils/dynahash.h"
 #include "utils/memutils.h"
+#include "utils/lsyscache.h"
 #include "utils/sharedtuplestore.h"
+#include "utils/syscache.h"
 
 
 /*
@@ -143,10 +152,87 @@ static TupleTableSlot *ExecHashJoinGetSavedTuple(HashJoinState *hjstate,
 												 BufFile *file,
 												 uint32 *hashvalue,
 												 TupleTableSlot *tupleSlot);
+static void ExecHashJoinSaveTuple(MinimalTuple tuple, uint32 hashvalue,
+								  BufFile **fileptr);
 static bool ExecHashJoinNewBatch(HashJoinState *hjstate);
 static bool ExecParallelHashJoinNewBatch(HashJoinState *hjstate);
 static void ExecParallelHashJoinPartitionOuter(HashJoinState *node);
 
+static void ExecHashIncreaseNumBatches(HashJoinTable hashtable);
+static void ExecHashIncreaseNumBuckets(HashJoinTable hashtable);
+static void ExecParallelHashIncreaseNumBatches(HashJoinTable hashtable);
+static void ExecParallelHashIncreaseNumBuckets(HashJoinTable hashtable);
+static void ExecHashBuildSkewHash(HashJoinTable hashtable, HashJoin *node,
+								  int mcvsToUse);
+static void ExecHashSkewTableInsert(HashJoinTable hashtable,
+									TupleTableSlot *slot,
+									uint32 hashvalue,
+									int bucketNumber);
+static void ExecHashRemoveNextSkewBucket(HashJoinTable hashtable);
+
+static void *dense_alloc(HashJoinTable hashtable, Size size);
+static HashJoinTuple ExecParallelHashTupleAlloc(HashJoinTable hashtable,
+												size_t size,
+												dsa_pointer *shared);
+static void ExecHashBuildPrivate(HashJoinState *node);
+static void ExecHashBuildParallel(HashJoinState *node);
+static inline HashJoinTuple ExecParallelHashFirstTuple(HashJoinTable table,
+													   int bucketno);
+static inline HashJoinTuple ExecParallelHashNextTuple(HashJoinTable table,
+													  HashJoinTuple tuple);
+static inline void ExecParallelHashPushTuple(dsa_pointer_atomic *head,
+											 HashJoinTuple tuple,
+											 dsa_pointer tuple_shared);
+static void ExecParallelHashJoinSetUpBatches(HashJoinTable hashtable, int nbatch);
+static void ExecParallelHashEnsureBatchAccessors(HashJoinTable hashtable);
+static void ExecParallelHashRepartitionFirst(HashJoinTable hashtable);
+static void ExecParallelHashRepartitionRest(HashJoinTable hashtable);
+static HashMemoryChunk ExecParallelHashPopChunkQueue(HashJoinTable table,
+													 dsa_pointer *shared);
+static bool ExecParallelHashTuplePrealloc(HashJoinTable hashtable,
+										  int batchno,
+										  size_t size);
+static void ExecParallelHashMergeCounters(HashJoinTable hashtable);
+static void ExecParallelHashCloseBatchAccessors(HashJoinTable hashtable);
+
+static HashJoinTable ExecHashTableCreate(HashJoinState *state, List *hashOperators, List *hashCollations,
+										 bool keepNulls);
+static void ExecParallelHashTableAlloc(HashJoinTable hashtable,
+									   int batchno);
+static void ExecHashTableDestroy(HashJoinTable hashtable);
+static void ExecHashTableDetach(HashJoinTable hashtable);
+static void ExecHashTableDetachBatch(HashJoinTable hashtable);
+static void ExecParallelHashTableSetCurrentBatch(HashJoinTable hashtable,
+												 int batchno);
+
+static void ExecHashTableInsert(HashJoinTable hashtable,
+								TupleTableSlot *slot,
+								uint32 hashvalue);
+static void ExecParallelHashTableInsert(HashJoinTable hashtable,
+										TupleTableSlot *slot,
+										uint32 hashvalue);
+static void ExecParallelHashTableInsertCurrentBatch(HashJoinTable hashtable,
+													TupleTableSlot *slot,
+													uint32 hashvalue);
+static bool ExecHashGetHashValue(HashJoinTable hashtable,
+								 ExprContext *econtext,
+								 List *hashkeys,
+								 bool outer_tuple,
+								 bool keep_nulls,
+								 uint32 *hashvalue);
+static void ExecHashGetBucketAndBatch(HashJoinTable hashtable,
+									  uint32 hashvalue,
+									  int *bucketno,
+									  int *batchno);
+static bool ExecScanHashBucket(HashJoinState *hjstate, ExprContext *econtext);
+static bool ExecParallelScanHashBucket(HashJoinState *hjstate, ExprContext *econtext);
+static void ExecPrepHashTableForUnmatched(HashJoinState *hjstate);
+static bool ExecScanHashTableForUnmatched(HashJoinState *hjstate,
+										  ExprContext *econtext);
+static void ExecHashTableReset(HashJoinTable hashtable);
+static void ExecHashTableResetMatchFlags(HashJoinTable hashtable);
+static int	ExecHashGetSkewBucket(HashJoinTable hashtable, uint32 hashvalue);
+
 
 /* ----------------------------------------------------------------
  *		ExecHashJoinImpl
@@ -166,7 +252,6 @@ ExecHashJoinImpl(PlanState *pstate, bool parallel)
 {
 	HashJoinState *node = castNode(HashJoinState, pstate);
 	PlanState  *outerNode;
-	HashState  *hashNode;
 	ExprState  *joinqual;
 	ExprState  *otherqual;
 	ExprContext *econtext;
@@ -181,11 +266,10 @@ ExecHashJoinImpl(PlanState *pstate, bool parallel)
 	 */
 	joinqual = node->js.joinqual;
 	otherqual = node->js.ps.qual;
-	hashNode = (HashState *) innerPlanState(node);
 	outerNode = outerPlanState(node);
 	hashtable = node->hj_HashTable;
 	econtext = node->js.ps.ps_ExprContext;
-	parallel_state = hashNode->parallel_state;
+	parallel_state = node->parallel_state;
 
 	/*
 	 * Reset per-tuple memory context to free any expression evaluation
@@ -256,7 +340,8 @@ ExecHashJoinImpl(PlanState *pstate, bool parallel)
 					node->hj_FirstOuterTupleSlot = NULL;
 				}
 				else if (HJ_FILL_OUTER(node) ||
-						 (outerNode->plan->startup_cost < hashNode->ps.plan->total_cost &&
+						 // FIXME: this isn't correct, needs to include the cost of building the hashtable?
+						 (outerNode->plan->startup_cost < innerPlanState(node)->plan->total_cost &&
 						  !node->hj_OuterNotEmpty))
 				{
 					node->hj_FirstOuterTupleSlot = ExecProcNode(outerNode);
@@ -276,7 +361,7 @@ ExecHashJoinImpl(PlanState *pstate, bool parallel)
 				 * whoever gets here first will create the hash table and any
 				 * later arrivals will merely attach to it.
 				 */
-				hashtable = ExecHashTableCreate(hashNode,
+				hashtable = ExecHashTableCreate(node,
 												node->hj_HashOperators,
 												node->hj_Collations,
 												HJ_FILL_INNER(node));
@@ -287,8 +372,13 @@ ExecHashJoinImpl(PlanState *pstate, bool parallel)
 				 * Parallel Hash, then we'll try to help hashing unless we
 				 * arrived too late.
 				 */
-				hashNode->hashtable = hashtable;
-				(void) MultiExecProcNode((PlanState *) hashNode);
+				node->hashtable = hashtable;
+
+				/* fill the hash table */
+				if (node->parallel_state != NULL)
+					ExecHashBuildParallel(node);
+				else
+					ExecHashBuildPrivate(node);
 
 				/*
 				 * If the inner relation is completely empty, and we're not
@@ -599,10 +689,13 @@ ExecInitHashJoin(HashJoin *node, EState *estate, int eflags)
 {
 	HashJoinState *hjstate;
 	Plan	   *outerNode;
-	Hash	   *hashNode;
+	Plan	   *innerNode;
 	TupleDesc	outerDesc,
 				innerDesc;
-	const TupleTableSlotOps *ops;
+	const TupleTableSlotOps *innerOps;
+	const TupleTableSlotOps *outerOps;
+	bool		innerOpsFixed;
+	bool		outerOpsFixed;
 
 	/* check for unsupported flags */
 	Assert(!(eflags & (EXEC_FLAG_BACKWARD | EXEC_FLAG_MARK)));
@@ -637,12 +730,26 @@ ExecInitHashJoin(HashJoin *node, EState *estate, int eflags)
 	 * clear if this would be a win or not.
 	 */
 	outerNode = outerPlan(node);
-	hashNode = (Hash *) innerPlan(node);
+	innerNode = innerPlan(node);
 
 	outerPlanState(hjstate) = ExecInitNode(outerNode, estate, eflags);
 	outerDesc = ExecGetResultType(outerPlanState(hjstate));
-	innerPlanState(hjstate) = ExecInitNode((Plan *) hashNode, estate, eflags);
+	outerOps = ExecGetResultSlotOps(outerPlanState(hjstate), &outerOpsFixed);
+	innerPlanState(hjstate) = ExecInitNode(innerNode, estate, eflags);
 	innerDesc = ExecGetResultType(innerPlanState(hjstate));
+	innerOps = ExecGetResultSlotOps(innerPlanState(hjstate), &innerOpsFixed);
+
+	/*
+	 * For the majority of expressions the inner tuple will come from the hash
+	 * table, which stores minimal tuples.
+	 */
+	hjstate->hj_HashTupleSlot =
+		ExecAllocTableSlot(&estate->es_tupleTable,
+						   innerDesc,
+						   &TTSOpsMinimalTuple);
+	hjstate->js.ps.inneropsset = true;
+	hjstate->js.ps.innerops = &TTSOpsMinimalTuple;
+	hjstate->js.ps.inneropsfixed = true;
 
 	/*
 	 * Initialize result slot, type and projection.
@@ -653,9 +760,8 @@ ExecInitHashJoin(HashJoin *node, EState *estate, int eflags)
 	/*
 	 * tuple table initialization
 	 */
-	ops = ExecGetResultSlotOps(outerPlanState(hjstate), NULL);
 	hjstate->hj_OuterTupleSlot = ExecInitExtraTupleSlot(estate, outerDesc,
-														ops);
+														outerOps);
 
 	/*
 	 * detect whether we need only consider the first matching inner tuple
@@ -689,20 +795,6 @@ ExecInitHashJoin(HashJoin *node, EState *estate, int eflags)
 				 (int) node->join.jointype);
 	}
 
-	/*
-	 * now for some voodoo.  our temporary tuple slot is actually the result
-	 * tuple slot of the Hash node (which is our inner plan).  we can do this
-	 * because Hash nodes don't return tuples via ExecProcNode() -- instead
-	 * the hash join node uses ExecScanHashBucket() to get at the contents of
-	 * the hash table.  -cim 6/9/91
-	 */
-	{
-		HashState  *hashstate = (HashState *) innerPlanState(hjstate);
-		TupleTableSlot *slot = hashstate->ps.ps_ResultTupleSlot;
-
-		hjstate->hj_HashTupleSlot = slot;
-	}
-
 	/*
 	 * initialize child expressions
 	 */
@@ -724,7 +816,21 @@ ExecInitHashJoin(HashJoin *node, EState *estate, int eflags)
 	hjstate->hj_CurSkewBucketNo = INVALID_SKEW_BUCKET_NO;
 	hjstate->hj_CurTuple = NULL;
 
-	hjstate->hj_OuterHashKeys = ExecInitExprList(node->hashkeys,
+	hjstate->hj_OuterHashKeys = ExecInitExprList(node->hashkeys_outer,
+												 (PlanState *) hjstate);
+
+	hjstate->js.ps.inneropsset = true;
+	hjstate->js.ps.innerops = &TTSOpsMinimalTuple;
+	hjstate->js.ps.inneropsfixed = true;
+
+	/*
+	 *
+	 */
+	hjstate->js.ps.inneropsset = true;
+	hjstate->js.ps.innerops = innerOps;
+	hjstate->js.ps.inneropsfixed = innerOpsFixed;
+
+	hjstate->hj_InnerHashKeys = ExecInitExprList(node->hashkeys_inner,
 												 (PlanState *) hjstate);
 	hjstate->hj_HashOperators = node->hashoperators;
 	hjstate->hj_Collations = node->hashcollations;
@@ -1195,7 +1301,7 @@ ExecParallelHashJoinNewBatch(HashJoinState *hjstate)
  * context, not in a shorter-lived context; else the temp file buffers
  * will get messed up.
  */
-void
+static void
 ExecHashJoinSaveTuple(MinimalTuple tuple, uint32 hashvalue,
 					  BufFile **fileptr)
 {
@@ -1360,6 +1466,31 @@ ExecShutdownHashJoin(HashJoinState *node)
 		ExecHashTableDetachBatch(node->hj_HashTable);
 		ExecHashTableDetach(node->hj_HashTable);
 	}
+
+
+	/*
+	 * Copy instrumentation data from this worker's hash table (if it built one)
+	 * to DSM memory so the leader can retrieve it.  This must be done in an
+	 * ExecShutdownHash() rather than ExecEndHash() because the latter runs after
+	 * we've detached from the DSM segment.
+	 */
+	if (node->hinstrument && node->hashtable)
+		ExecHashJoinGetInstrumentation(node->hinstrument, node->hashtable);
+}
+
+/*
+ * Copy the instrumentation data from 'hashtable' into a HashInstrumentation
+ * struct.
+ */
+void
+ExecHashJoinGetInstrumentation(HashInstrumentation *instrument,
+						   HashJoinTable hashtable)
+{
+	instrument->nbuckets = hashtable->nbuckets;
+	instrument->nbuckets_original = hashtable->nbuckets_original;
+	instrument->nbatch = hashtable->nbatch;
+	instrument->nbatch_original = hashtable->nbatch_original;
+	instrument->space_peak = hashtable->spacePeak;
 }
 
 static void
@@ -1411,17 +1542,51 @@ ExecParallelHashJoinPartitionOuter(HashJoinState *hjstate)
 void
 ExecHashJoinEstimate(HashJoinState *state, ParallelContext *pcxt)
 {
-	shm_toc_estimate_chunk(&pcxt->estimator, sizeof(ParallelHashJoinState));
-	shm_toc_estimate_keys(&pcxt->estimator, 1);
+	size_t		size;
+
+	/* Even when not parallel-aware, for EXPLAIN ANALYZE */
+	if (state->js.ps.instrument || pcxt->nworkers > 0)
+	{
+		size = mul_size(pcxt->nworkers, sizeof(HashInstrumentation));
+		size = add_size(size, offsetof(SharedHashInfo, hinstrument));
+		shm_toc_estimate_chunk(&pcxt->estimator, size);
+		shm_toc_estimate_keys(&pcxt->estimator, 1);
+	}
+
+	if (state->js.ps.plan->parallel_aware)
+	{
+		shm_toc_estimate_chunk(&pcxt->estimator, sizeof(ParallelHashJoinState));
+		shm_toc_estimate_keys(&pcxt->estimator, 1);
+	}
 }
 
 void
 ExecHashJoinInitializeDSM(HashJoinState *state, ParallelContext *pcxt)
 {
 	int			plan_node_id = state->js.ps.plan->plan_node_id;
-	HashState  *hashNode;
 	ParallelHashJoinState *pstate;
 
+	/* even when not parallel-aware, for EXPLAIN ANALYZE */
+	/*
+	 * For hashtable, but don't need this if not instrumenting or no workers.
+	 */
+	if (state->js.ps.instrument || pcxt->nworkers > 0)
+	{
+		size_t		size;
+
+		size = offsetof(SharedHashInfo, hinstrument) +
+			pcxt->nworkers * sizeof(HashInstrumentation);
+		state->shared_info = (SharedHashInfo *) shm_toc_allocate(pcxt->toc, size);
+		memset(state->shared_info, 0, size);
+		state->shared_info->num_workers = pcxt->nworkers;
+		// FIXME: Hack -
+		shm_toc_insert(pcxt->toc, -state->js.ps.plan->plan_node_id,
+					   state->shared_info);
+	}
+
+	if (!state->js.ps.plan->parallel_aware)
+		return;
+
 	/*
 	 * Disable shared hash table mode if we failed to create a real DSM
 	 * segment, because that means that we don't have a DSA area to work with.
@@ -1462,9 +1627,9 @@ ExecHashJoinInitializeDSM(HashJoinState *state, ParallelContext *pcxt)
 	/* Set up the space we'll use for shared temporary files. */
 	SharedFileSetInit(&pstate->fileset, pcxt->seg);
 
-	/* Initialize the shared state in the hash node. */
-	hashNode = (HashState *) innerPlanState(state);
-	hashNode->parallel_state = pstate;
+	state->parallel_state = pstate;
+
+
 }
 
 /* ----------------------------------------------------------------
